# absinth

Absinth is a graph based approach to word sense induction. Out system is based on Hyperlex (Véronis 2004) and made for SemEval-2013 Task 11 (Navigli, Vannella).

## Getting Started

Clone our system using git.

```
$ git clone https://gitlab.cl.uni-heidelberg.de/zimmermann/absinth/
```

### Prerequisites

Download the evaluator and dataset from the task page and place them in the appropriate folders. This repository already includes a version of this evaluator. For proper testing however, the official one should be used.


https://www.cs.york.ac.uk/semeval-2013/task11/index.php%3Fid=data.html


### Installing

A step by step series of examples that tell you have to get a development env running

Change to source directory.

```
$ cd absinth/src
```

Run setup.sh. This installs mandatory modules and creates folders for
temporary output.

```
$ bash setup.sh
```

Specify paths and (if appropriate) other variables for our system.

```
$ emacs config.py
```

## Deployment

Run absinth without modifiers to use the dataset path and with '-t' for the trial path.

```
$ python3 absinth.py
```

```
$ python3 absinth.py -t
```

Absinth may utilise multiprocessing for parallel topic processing. Simply put
'-p' followed by the number of processes after the program name.

```
$ python3 absinth.py -p 4
```

Absinth produces individual clustering files for every target. To merge the 
output files, simple call merge.py. The resulting output for the WSI-evaluator
is placed in the 'absinth/src/final' directory.

```
$ python3 merge.py
```

Absinth does not overwrite already processed topics. Please delete files you
wish to replace manually.

## Baseline

Our baseline 'abstinent.py' works in much the same way as absinth.py. Not all
variables in config.py are supported in our baseline though.

```
$ python3 abstinent.py -t -p 3
```

To merge the abstinent.py output, simply put the '-bl' modifier behind merge.py:

```
$ python3 merge.py -bl
```

View the documentation for more information.

## Built With

* [NetworkX](https://networkx.github.io/) - Graph implementation
* [Spacy](https://spacy.io/) - Tokenisation and syntactic parsing
* [NumPy](http://www.numpy.org/) - Maths
* [SciPy](https://www.scipy.org/) - More maths

## References

Di Marco, Antonio and Navigli, Roberto (2013). Clustering and Diversifying Web Search Results with Graph-Based Word Sense Induction. Computational Linguistics, 39(3). doi:10.1162/COLI_a_00148

Hamilton, William L. and Clark, Kevin and Leskovec, Jure and Jurafsky, Dan. Inducing Domain-Specific Sentiment Lexicons from Unlabeled Corpora. Proceedings of the 2016 Conference on Empirical Methods in Natural Language Processing, 595--605. doi:10.18653/v1/D16-1057

Kruskal, J. (1956). On the Shortest Spanning Subtree of a Graph and the Traveling Salesman Problem. Proceedings of the American Mathematical Society, 7(1), 48-50. doi:10.2307/2033241

Véronis, Jean. (2004). HyperLex: Lexical cartography for information retrieval. Computer Speech & Language. doi:10.1016/j.csl.2004.05.002

## Authors

* **Maja Hoffmann** - [hoffmann](https://gitlab.cl.uni-heidelberg.de/hoffmann/)
* **Victor Zimmermann** - [zimmermann](http://www.cl.uni-heidelberg.de/~zimmermann/)

## License

This project is licensed under the MIT License - see the [LICENSE](LICENSE) file for details

## Acknowledgments

* In Loving Memory of Bente Nittka.
